refactor(terraform): 2n_aws_c5n
[csit.git] / resources / libraries / bash / function / common.sh
index ed3b204..7595f17 100644 (file)
@@ -1,5 +1,5 @@
-# Copyright (c) 2021 Cisco and/or its affiliates.
-# Copyright (c) 2021 PANTHEON.tech and/or its affiliates.
+# Copyright (c) 2022 Cisco and/or its affiliates.
+# Copyright (c) 2022 PANTHEON.tech and/or its affiliates.
 # Licensed under the Apache License, Version 2.0 (the "License");
 # you may not use this file except in compliance with the License.
 # You may obtain a copy of the License at:
@@ -79,12 +79,14 @@ function activate_docker_topology () {
          die "Trap attempt failed, please cleanup manually. Aborting!"
     }
 
+    parse_env_variables || die "Parse of environment variables failed!"
+
     # Replace all variables in template with those in environment.
     source <(echo 'cat <<EOF >topo.yml'; cat ${TOPOLOGIES[0]}; echo EOF;) || {
         die "Topology file create failed!"
     }
 
-    WORKING_TOPOLOGY="/tmp/topology.yaml"
+    WORKING_TOPOLOGY="${CSIT_DIR}/topologies/available/vpp_device.yaml"
     mv topo.yml "${WORKING_TOPOLOGY}" || {
         die "Topology move failed!"
     }
@@ -135,19 +137,19 @@ function activate_virtualenv () {
 
 function archive_tests () {
 
-    # Create .tar.xz of generated/tests for archiving.
+    # Create .tar.gz of generated/tests for archiving.
     # To be run after generate_tests, kept separate to offer more flexibility.
 
     # Directory read:
     # - ${GENERATED_DIR}/tests - Tree of executed suites to archive.
     # File rewriten:
-    # - ${ARCHIVE_DIR}/tests.tar.xz - Archive of generated tests.
+    # - ${ARCHIVE_DIR}/generated_tests.tar.gz - Archive of generated tests.
 
     set -exuo pipefail
 
-    tar c "${GENERATED_DIR}/tests" | xz -3 > "${ARCHIVE_DIR}/tests.tar.xz" || {
-        die "Error creating archive of generated tests."
-    }
+    pushd "${ARCHIVE_DIR}" || die
+    tar czf "generated_tests.tar.gz" "${GENERATED_DIR}/tests" || true
+    popd || die
 }
 
 
@@ -453,18 +455,26 @@ function get_test_code () {
             NODENESS="2n"
             FLAVOR="skx"
             ;;
-        *"2n-zn2"*)
-            NODENESS="2n"
-            FLAVOR="zn2"
-            ;;
         *"3n-skx"*)
             NODENESS="3n"
             FLAVOR="skx"
             ;;
+        *"2n-zn2"*)
+            NODENESS="2n"
+            FLAVOR="zn2"
+            ;;
         *"2n-clx"*)
             NODENESS="2n"
             FLAVOR="clx"
             ;;
+        *"2n-icx"*)
+            NODENESS="2n"
+            FLAVOR="icx"
+            ;;
+        *"3n-icx"*)
+            NODENESS="3n"
+            FLAVOR="icx"
+            ;;
         *"2n-dnv"*)
             NODENESS="2n"
             FLAVOR="dnv"
@@ -481,11 +491,6 @@ function get_test_code () {
             NODENESS="3n"
             FLAVOR="tsh"
             ;;
-        *)
-            # Fallback to 3-node Haswell by default (backward compatibility)
-            NODENESS="3n"
-            FLAVOR="hsw"
-            ;;
     esac
 }
 
@@ -539,9 +544,6 @@ function get_test_tag_string () {
             elif [[ "${test_tag_array[0]}" == "skx" ]]; then
                 export GRAPH_NODE_VARIANT="skx"
                 TEST_TAG_STRING="${test_tag_array[@]:1}" || true
-            elif [[ "${test_tag_array[0]}" == "hsw" ]]; then
-                export GRAPH_NODE_VARIANT="hsw"
-                TEST_TAG_STRING="${test_tag_array[@]:1}" || true
             fi
         fi
     fi
@@ -607,6 +609,73 @@ function move_archives () {
 }
 
 
+function post_process_robot_outputs () {
+
+    # Generate INFO level output_info.xml by rebot.
+    # Archive UTI raw json outputs.
+    #
+    # Variables read:
+    # - ARCHIVE_DIR - Path to post-processed files.
+
+    set -exuo pipefail
+
+    # Compress raw json outputs, as they will never be post-processed.
+    pushd "${ARCHIVE_DIR}" || die
+    if [ -d "tests" ]; then
+        # Use deterministic order.
+        options+=("--sort=name")
+        # We are keeping info outputs where they are.
+        # Assuming we want to move anything but info files (and dirs).
+        options+=("--exclude=*.info.json")
+        tar czf "generated_output_raw.tar.gz" "${options[@]}" "tests" || true
+        # Tar can remove when archiving, but chokes (not deterministically)
+        # on attempting to remove dirs (not empty as info files are there).
+        # So we need to delete the raw files manually.
+        find "tests" -type f -name "*.raw.json" -delete || true
+    fi
+    popd || die
+
+    # Generate INFO level output_info.xml for post-processing.
+    all_options=("--loglevel" "INFO")
+    all_options+=("--log" "none")
+    all_options+=("--report" "none")
+    all_options+=("--output" "${ARCHIVE_DIR}/output_info.xml")
+    all_options+=("${ARCHIVE_DIR}/output.xml")
+    rebot "${all_options[@]}" || true
+}
+
+
+function prepare_topology () {
+
+    # Prepare virtual testbed topology if needed based on flavor.
+
+    # Variables read:
+    # - TEST_CODE - String affecting test selection, usually jenkins job name.
+    # - NODENESS - Node multiplicity of testbed, either "2n" or "3n".
+    # - FLAVOR - Node flavor string, e.g. "clx" or "skx".
+    # Functions called:
+    # - die - Print to stderr and exit.
+    # - terraform_init - Terraform init topology.
+    # - terraform_apply - Terraform apply topology.
+
+    set -exuo pipefail
+
+    case_text="${NODENESS}_${FLAVOR}"
+    case "${case_text}" in
+        "2n_aws")
+            export TF_VAR_testbed_name="${TEST_CODE}"
+            terraform_init || die "Failed to call terraform init."
+            terraform_apply || die "Failed to call terraform apply."
+            ;;
+        "3n_aws")
+            export TF_VAR_testbed_name="${TEST_CODE}"
+            terraform_init || die "Failed to call terraform init."
+            terraform_apply || die "Failed to call terraform apply."
+            ;;
+    esac
+}
+
+
 function reserve_and_cleanup_testbed () {
 
     # Reserve physical testbed, perform cleanup, register trap to unreserve.
@@ -686,7 +755,9 @@ function reserve_and_cleanup_testbed () {
 
 function run_pybot () {
 
-    # Run pybot with options based on input variables. Create output_info.xml
+    # Run pybot with options based on input variables.
+    # Generate INFO level output_info.xml by rebot.
+    # Archive UTI raw json outputs.
     #
     # Variables read:
     # - CSIT_DIR - Path to existing root of local CSIT git repository.
@@ -710,13 +781,8 @@ function run_pybot () {
     PYBOT_EXIT_STATUS="$?"
     set -e
 
-    # Generate INFO level output_info.xml for post-processing.
-    all_options=("--loglevel" "INFO")
-    all_options+=("--log" "none")
-    all_options+=("--report" "none")
-    all_options+=("--output" "${ARCHIVE_DIR}/output_info.xml")
-    all_options+=("${ARCHIVE_DIR}/output.xml")
-    rebot "${all_options[@]}" || true
+    post_process_robot_outputs || die
+
     popd || die "Change directory operation failed."
 }
 
@@ -806,10 +872,13 @@ function select_tags () {
         *"3n-tsh"*)
             default_nic="nic_intel-x520-da2"
             ;;
+        *"3n-icx"* | *"2n-icx"*)
+            default_nic="nic_intel-xxv710"
+            ;;
         *"3n-skx"* | *"2n-skx"* | *"2n-clx"* | *"2n-zn2"*)
             default_nic="nic_intel-xxv710"
             ;;
-        *"3n-hsw"* | *"2n-tx2"* | *"mrr-daily-master")
+        *"2n-tx2"* | *"mrr-daily-master")
             default_nic="nic_intel-xl710"
             ;;
         *"2n-aws"* | *"3n-aws"*)
@@ -828,18 +897,28 @@ function select_tags () {
     awk_nics_sub_cmd+='gsub("x520-da2","10ge2p1x520");'
     awk_nics_sub_cmd+='gsub("x553","10ge2p1x553");'
     awk_nics_sub_cmd+='gsub("cx556a","100ge2p1cx556a");'
+    awk_nics_sub_cmd+='gsub("e810cq","100ge2p1e810cq");'
     awk_nics_sub_cmd+='gsub("vic1227","10ge2p1vic1227");'
     awk_nics_sub_cmd+='gsub("vic1385","40ge2p1vic1385");'
     awk_nics_sub_cmd+='gsub("nitro-50g","50ge1p1ENA");'
     awk_nics_sub_cmd+='if ($9 =="drv_avf") drv="avf-";'
     awk_nics_sub_cmd+='else if ($9 =="drv_rdma_core") drv ="rdma-";'
+    awk_nics_sub_cmd+='else if ($9 =="drv_af_xdp") drv ="af-xdp-";'
     awk_nics_sub_cmd+='else drv="";'
-    awk_nics_sub_cmd+='print "*"$7"-" drv $11"-"$5"."$3"-"$1"-" drv $11"-"$5'
+    awk_nics_sub_cmd+='if ($1 =="-") cores="";'
+    awk_nics_sub_cmd+='else cores=$1;'
+    awk_nics_sub_cmd+='print "*"$7"-" drv $11"-"$5"."$3"-" cores "-" drv $11"-"$5'
 
     # Tag file directory shorthand.
     tfd="${JOB_SPECS_DIR}"
     case "${TEST_CODE}" in
         # Select specific performance tests based on jenkins job type variable.
+        *"device"* )
+            readarray -t test_tag_array <<< $(grep -v "#" \
+                ${tfd}/vpp_device/${DUT}-${NODENESS}-${FLAVOR}.md |
+                awk {"$awk_nics_sub_cmd"} || echo "devicetest") || die
+            SELECTION_MODE="--test"
+            ;;
         *"ndrpdr-weekly"* )
             readarray -t test_tag_array <<< $(grep -v "#" \
                 ${tfd}/mlr_weekly/${DUT}-${NODENESS}-${FLAVOR}.md |
@@ -880,11 +959,11 @@ function select_tags () {
             if [[ -z "${TEST_TAG_STRING-}" ]]; then
                 # If nothing is specified, we will run pre-selected tests by
                 # following tags.
-                test_tag_array=("mrrAND${default_nic}AND1cAND64bANDip4base"
-                                "mrrAND${default_nic}AND1cAND78bANDip6base"
-                                "mrrAND${default_nic}AND1cAND64bANDl2bdbase"
-                                "mrrAND${default_nic}AND1cAND64bANDl2xcbase"
-                                "!dot1q" "!drv_avf")
+                test_tag_array=("mrrAND${default_nic}AND1cAND64bANDethip4-ip4base"
+                                "mrrAND${default_nic}AND1cAND78bANDethip6-ip6base"
+                                "mrrAND${default_nic}AND1cAND64bANDeth-l2bdbasemaclrn"
+                                "mrrAND${default_nic}AND1cAND64bANDeth-l2xcbase"
+                                "!drv_af_xdp" "!drv_avf")
             else
                 # If trigger contains tags, split them into array.
                 test_tag_array=(${TEST_TAG_STRING//:/ })
@@ -897,8 +976,15 @@ function select_tags () {
     #
     # Reasons for blacklisting:
     # - ipsechw - Blacklisted on testbeds without crypto hardware accelerator.
-    # TODO: Add missing reasons here (if general) or where used (if specific).
     case "${TEST_CODE}" in
+        *"1n-vbox"*)
+            test_tag_array+=("!avf")
+            test_tag_array+=("!vhost")
+            test_tag_array+=("!flow")
+            ;;
+        *"1n_tx2"*)
+            test_tag_array+=("!flow")
+            ;;
         *"2n-skx"*)
             test_tag_array+=("!ipsechw")
             ;;
@@ -910,11 +996,18 @@ function select_tags () {
         *"2n-clx"*)
             test_tag_array+=("!ipsechw")
             ;;
+        *"2n-icx"*)
+            test_tag_array+=("!ipsechw")
+            ;;
+        *"3n-icx"*)
+            test_tag_array+=("!ipsechw")
+            # Not enough nic_intel-xxv710 to support double link tests.
+            test_tag_array+=("!3_node_double_link_topoANDnic_intel-xxv710")
+            ;;
         *"2n-zn2"*)
             test_tag_array+=("!ipsechw")
             ;;
         *"2n-dnv"*)
-            test_tag_array+=("!ipsechw")
             test_tag_array+=("!memif")
             test_tag_array+=("!srv6_proxy")
             test_tag_array+=("!vhost")
@@ -936,21 +1029,9 @@ function select_tags () {
             test_tag_array+=("!drv_avf")
             test_tag_array+=("!ipsechw")
             ;;
-        *"3n-hsw"*)
-            test_tag_array+=("!drv_avf")
-            # All cards have access to QAT. But only one card (xl710)
-            # resides in same NUMA as QAT. Other cards must go over QPI
-            # which we do not want to even run.
-            test_tag_array+=("!ipsechwNOTnic_intel-xl710")
-            ;;
         *"2n-aws"* | *"3n-aws"*)
             test_tag_array+=("!ipsechw")
             ;;
-        *)
-            # Default to 3n-hsw due to compatibility.
-            test_tag_array+=("!drv_avf")
-            test_tag_array+=("!ipsechwNOTnic_intel-xl710")
-            ;;
     esac
 
     # We will add excluded NICs.
@@ -961,12 +1042,14 @@ function select_tags () {
 
     set +x
     if [[ "${TEST_CODE}" == "vpp-"* ]]; then
-        # Automatic prefixing for VPP jobs to limit the NIC used and
-        # traffic evaluation to MRR.
-        if [[ "${TEST_TAG_STRING-}" == *"nic_"* ]]; then
-            prefix="${prefix}mrrAND"
-        else
-            prefix="${prefix}mrrAND${default_nic}AND"
+        if [[ "${TEST_CODE}" != *"device"* ]]; then
+            # Automatic prefixing for VPP perf jobs to limit the NIC used and
+            # traffic evaluation to MRR.
+            if [[ "${TEST_TAG_STRING-}" == *"nic_"* ]]; then
+                prefix="${prefix}mrrAND"
+            else
+                prefix="${prefix}mrrAND${default_nic}AND"
+            fi
         fi
     fi
     for tag in "${test_tag_array[@]}"; do
@@ -1000,7 +1083,7 @@ function select_topology () {
 
     # Variables read:
     # - NODENESS - Node multiplicity of testbed, either "2n" or "3n".
-    # - FLAVOR - Node flavor string, currently either "hsw" or "skx".
+    # - FLAVOR - Node flavor string, e.g. "clx" or "skx".
     # - CSIT_DIR - Path to existing root of local CSIT git repository.
     # - TOPOLOGIES_DIR - Path to existing directory with available topologies.
     # Variables set:
@@ -1013,8 +1096,6 @@ function select_topology () {
 
     case_text="${NODENESS}_${FLAVOR}"
     case "${case_text}" in
-        # TODO: Move tags to "# Blacklisting certain tags per topology" section.
-        # TODO: Double link availability depends on NIC used.
         "1n_vbox")
             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*vpp_device*.template )
             TOPOLOGIES_TAGS="2_node_single_link_topo"
@@ -1035,10 +1116,18 @@ function select_topology () {
             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_skx*.yaml )
             TOPOLOGIES_TAGS="3_node_*_link_topo"
             ;;
+        "3n_icx")
+            TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_icx*.yaml )
+            TOPOLOGIES_TAGS="3_node_*_link_topo"
+            ;;
         "2n_clx")
             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_clx*.yaml )
             TOPOLOGIES_TAGS="2_node_*_link_topo"
             ;;
+        "2n_icx")
+            TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_icx*.yaml )
+            TOPOLOGIES_TAGS="2_node_*_link_topo"
+            ;;
         "2n_dnv")
             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_dnv*.yaml )
             TOPOLOGIES_TAGS="2_node_single_link_topo"
@@ -1047,10 +1136,6 @@ function select_topology () {
             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_dnv*.yaml )
             TOPOLOGIES_TAGS="3_node_single_link_topo"
             ;;
-        "3n_hsw")
-            TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_hsw*.yaml )
-            TOPOLOGIES_TAGS="3_node_single_link_topo"
-            ;;
         "3n_tsh")
             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_tsh*.yaml )
             TOPOLOGIES_TAGS="3_node_single_link_topo"
@@ -1060,15 +1145,15 @@ function select_topology () {
             TOPOLOGIES_TAGS="2_node_single_link_topo"
             ;;
         "2n_aws")
-            TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_aws*.yaml )
+            TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n-aws*.yaml )
             TOPOLOGIES_TAGS="2_node_single_link_topo"
             ;;
         "3n_aws")
-            TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_aws*.yaml )
+            TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n-aws*.yaml )
             TOPOLOGIES_TAGS="3_node_single_link_topo"
             ;;
         *)
-            # No falling back to 3n_hsw default, that should have been done
+            # No falling back to default, that should have been done
             # by the function which has set NODENESS and FLAVOR.
             die "Unknown specification: ${case_text}"
     esac
@@ -1079,67 +1164,6 @@ function select_topology () {
 }
 
 
-function select_vpp_device_tags () {
-
-    # Variables read:
-    # - TEST_CODE - String affecting test selection, usually jenkins job name.
-    # - TEST_TAG_STRING - String selecting tags, from gerrit comment.
-    #   Can be unset.
-    # Variables set:
-    # - TAGS - Array of processed tag boolean expressions.
-
-    set -exuo pipefail
-
-    case "${TEST_CODE}" in
-        # Select specific device tests based on jenkins job type variable.
-        * )
-            if [[ -z "${TEST_TAG_STRING-}" ]]; then
-                # If nothing is specified, we will run pre-selected tests by
-                # following tags. Items of array will be concatenated by OR
-                # in Robot Framework.
-                test_tag_array=()
-            else
-                # If trigger contains tags, split them into array.
-                test_tag_array=(${TEST_TAG_STRING//:/ })
-            fi
-            SELECTION_MODE="--include"
-            ;;
-    esac
-
-    # Blacklisting certain tags per topology.
-    #
-    # Reasons for blacklisting:
-    # - avf - AVF is not possible to run on enic driver of VirtualBox.
-    # - vhost - VirtualBox does not support nesting virtualization on Intel CPU.
-    case "${TEST_CODE}" in
-        *"1n-vbox"*)
-            test_tag_array+=("!avf")
-            test_tag_array+=("!vhost")
-            ;;
-        *)
-            ;;
-    esac
-
-    TAGS=()
-
-    # We will prefix with devicetest to prevent running other tests
-    # (e.g. Functional).
-    prefix="devicetestAND"
-    if [[ "${TEST_CODE}" == "vpp-"* ]]; then
-        # Automatic prefixing for VPP jobs to limit testing.
-        prefix="${prefix}"
-    fi
-    for tag in "${test_tag_array[@]}"; do
-        if [[ ${tag} == "!"* ]]; then
-            # Exclude tags are not prefixed.
-            TAGS+=("${tag}")
-        else
-            TAGS+=("${prefix}${tag}")
-        fi
-    done
-}
-
-
 function set_environment_variables () {
 
     # Depending on testbed topology, overwrite defaults set in the
@@ -1157,6 +1181,7 @@ function set_environment_variables () {
             # T-Rex 2.88 workaround for ENA NICs
             export TREX_RX_DESCRIPTORS_COUNT=1024
             export TREX_EXTRA_CMDLINE="--mbuf-factor 19"
+            export TREX_CORE_COUNT=6
             # Settings to prevent duration stretching
             export PERF_TRIAL_STL_DELAY=0.1
             ;;
@@ -1198,6 +1223,13 @@ function untrap_and_unreserve_testbed () {
         python3 "${PYTHON_SCRIPTS_DIR}/topo_reservation.py" -c -t "${wt}" || {
             die "${1:-FAILED TO UNRESERVE, FIX MANUALLY.}" 2
         }
+        case "${TEST_CODE}" in
+            *"2n-aws"* | *"3n-aws"*)
+                terraform_destroy || die "Failed to call terraform destroy."
+                ;;
+            *)
+                ;;
+        esac
         WORKING_TOPOLOGY=""
         set -eu
     fi